CON
  _xinfreq = 5_000_000
  _clkmode = xtal1 + pll16x
                              
  'Robot Rate Constants
  STOP          = 0
  SUPERSLOW     = 20
  SLOW          = 35
  MEDIUM        = 55
  FAST          = 75
  SUPERFAST     = 90
  MAXSPEED      = 100
                    
  'Pete's Constants
  RIGHT         = 0
  LEFT          = 1  
  'Pings
  CLEAR         = 0
  ONRIGHT       = 1
  ONLEFT        = 2
  LANDR         = 3
  AHEADONLY     = 4
  AHEADANDR     = 5
  AHEADANDL     = 6
  ALL           = 7
  
  EDGER         = 1
  EDGEL         = 2

OBJ
  'MOTORS
  motors  :  "SRMotorControl"
  
PUB start : Success
  Success := motors.start
PUB stopmots
  motors.stop
  
PUB drive(pingfront, pingdown) | PREVDIR

  if pingfront OR pingdown                              'If we're turning
    motors.SetRamp(5)                                   'Ramp is 5
    motors.MoveForward(STOP)
    
  else
    motors.MoveForward(STOP)
    motors.SetRamp(8)                                   'If we're heading straight its almost full ramp
    
  {if pingdown                                          'We took the downward facing pings off in the end
    CASE pingdown                                       'since we didn't have them extended far enough in front
      EDGER:                                            'to actually make a difference when we did detect a change
        PREVDIR := LEFT
        motors.TurnCCW(SLOW)
      EDGEL:
        PREVDIR := RIGHT         
        motors.TurnCW(SLOW)
      
  else  }
  CASE pingfront                                        'Names of cases indicate where obstacle has been detected
      CLEAR:
        motors.MoveForward(MEDIUM)    
      ONRIGHT:
        PREVDIR := LEFT
        motors.TurnCCW(SLOW)
      ONLEFT:
        PREVDIR := RIGHT         
        motors.TurnCW(SLOW)
      LANDR:
        motors.MoveBackward(SLOW)
      AHEADONLY: 
        if PREVDIR == RIGHT
          motors.RotateCW(SLOW)
        else
          motors.RotateCCW(SLOW)
      AHEADANDR:
        motors.RotateCCW(SLOW)      
      AHEADANDL:
        motors.RotateCW(SLOW) 
      ALL:
        if PREVDIR == RIGHT
          motors.TurnBackCCW(SLOW) 
        else
          motors.TurnBackCW(SLOW)                                                                                
   
PUB halt
  motors.SetRamp(10)
  motors.MoveForward(STOP)

PUB break
  motors.Break         

'Used in MoveToHeading function
PUB slowpivotright 
  motors.RotateCCW(SUPERSLOW)                  
PUB slowpivotleft 
  motors.RotateCW(SUPERSLOW)